--
-- Table structure for table `mac_track_device_types`
--

DROP TABLE IF EXISTS `mac_track_device_types`;
CREATE TABLE `mac_track_device_types` (
  `device_type_id` int(10) unsigned NOT NULL auto_increment,
  `description` varchar(100) NOT NULL default '',
  `vendor` varchar(40) NOT NULL default '',
  `device_type` varchar(10) NOT NULL default '0',
  `sysDescr_match` varchar(20) NOT NULL default '',
  `sysObjectID_match` varchar(40) NOT NULL default '',
  `scanning_function` varchar(100) NOT NULL default '',
  `lowPort` int(10) unsigned NOT NULL default '0',
  `highPort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`device_type_id`),
  KEY `device_type` (`device_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `mac_track_device_types`
--


/*!40000 ALTER TABLE `mac_track_device_types` DISABLE KEYS */;
LOCK TABLES `mac_track_device_types` WRITE;
INSERT INTO `mac_track_device_types` VALUES (2,'2E253','Cabletron','1','2E253-49R','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(3,'2E42','Cabletron','1','2E42-27R','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(4,'2H252','Cabletron','1','2H252-25R','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(5,'6E132','Cabletron','1','6E132-25','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(6,'6E138','Cabletron','1','6E138-25','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(7,'6E233','Cabletron','1','6E233-49','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(8,'6H122','Cabletron','1','6H122-08','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(9,'6H202','Cabletron','1','6H202-24','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(10,'6H252-17','Cabletron','1','6H252-17','.1.3.6.1.4.1.52','get_cabletron_switch_ports',0,0),(11,'SEHI-24','Cabletron','1','SEHI','.1.3.6.1.4.1.52','get_repeater_rev4_ports',0,0),(12,'XP-6000 Router','Cabletron','3','XP-8600','.1.3.6.1.4.1.52','',0,0),(13,'6H352','Enterasys','1','6H352-25','.1.3.6.1.4.1.5624','get_cabletron_switch_ports',0,0),(14,'VH-2402','Enterasys','1','VH-2402S','.1.3.6.1.4.1.5624','get_cabletron_switch_ports',0,0),(15,'Catalyst 2900XL','Cisco','1','C2900XL-C3H2S-M','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(16,'Catalyst 2950','Cisco','1','C2950-I6K2L2Q4-M','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(17,'Catalyst 2950','Cisco','1','C2950-I6Q4L2-M2','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(18,'Catalyst 3550 Switch','Cisco','1','C3550-I5K2L2Q3-M','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(19,'Catalyst 3550 Switch','Cisco','1','C3550-I5Q3L2-M2','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(20,'Catalyst 3750 L3 Switch','Cisco','2','C3750-I5K91-M2','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(21,'Catalyst 3750 L3 Switch','Cisco','2','C3750-I5-M2','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(22,'4500 Router','Cisco','3','C4500-JS-M2','.1.3.6.1.4.1.9','',0,0),(23,'Catalyst 5000 RSM','Cisco','3','C5RSM-JSV-M2','.1.3.6.1.4.1.9','',0,0),(24,'Catalyst 6000 MSFC Router','Cisco','3','C6MSFC2-JK2SV-M2','.1.3.6.1.4.1.9','',0,0),(25,'Catalyst 6000 MSFC Router','Cisco','3','C6MSFC2-JSV-M2','.1.3.6.1.4.1.9','',0,0),(26,'Catalyst 6000 MSM Router','Cisco','3','C6MSM-IN-M2','.1.3.6.1.4.1.9','',0,0),(27,'Catalyst 6000 Router SupII','Cisco','2','c6sup2_rp-JK2SV-M','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(28,'Catalyst 6000 Router SupII','Cisco','2','c6sup2_rp-JS-M','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(29,'7301 Router','Cisco','3','C7301-JS-M2','.1.3.6.1.4.1.9','',0,0),(30,'Catalyst 8510 L2/L3 Switch','Cisco','3','C8510-IN-M','.1.3.6.1.4.1.9','',0,0),(31,'Catalyst 8540 L2/L3 Switch','Cisco','3','C8540CSR-IN-M','.1.3.6.1.4.1.9','',0,0),(32,'Catalyst 1900','Cisco','1','Catalyst 1900','.1.3.6.1.4.1.9','get_generic_switch_ports',0,0),(33,'Catalyst 2820','Cisco','1','Catalyst 2820','.1.3.6.1.4.1.9','get_generic_switch_ports',0,0),(34,'Route Switch Processor','Cisco','3','RSP-JSV-M2','.1.3.6.1.4.1.9','',0,0),(35,'Catalyst 3750','Cisco','2','WS-C3750-IPSERVICESK','.1.3.6.1.4.1.9','get_IOS_dot1dTpFdbEntry_ports',0,0),(36,'Catalyst 4003','Cisco','1','WS-C4003','.1.3.6.1.4.1.9','get_catalyst_dot1dTpFdbEntry_ports',0,0),(37,'Catalyst 4006','Cisco','1','WS-C4006','.1.3.6.1.4.1.9','get_catalyst_dot1dTpFdbEntry_ports',0,0),(38,'Catalyst 5500','Cisco','1','WS-C5500','.1.3.6.1.4.1.9','get_catalyst_dot1dTpFdbEntry_ports',0,0),(39,'Catalyst 5505','Cisco','1','WS-C5505','.1.3.6.1.4.1.9','get_catalyst_dot1dTpFdbEntry_ports',0,0),(40,'Catalyst 5509','Cisco','1','WS-C5509','.1.3.6.1.4.1.9','get_catalyst_dot1dTpFdbEntry_ports',0,0),(41,'Catalyst 6506','Cisco','1','WS-C6506','.1.3.6.1.4.1.9','get_catalyst_dot1dTpFdbEntry_ports',0,0),(42,'Catalyst 6509','Cisco','1','WS-C6509','.1.3.6.1.4.1.9','get_catalyst_dot1dTpFdbEntry_ports',0,0),(43,'Catalyst 6513','Cisco','1','WS-C6513','.1.3.6.1.4.1.9','get_catalyst_dot1dTpFdbEntry_ports',0,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mac_track_device_types` ENABLE KEYS */;

--
-- Table structure for table `mac_track_devices`
--

DROP TABLE IF EXISTS `mac_track_devices`;
CREATE TABLE `mac_track_devices` (
  `site_id` int(10) unsigned NOT NULL default '0',
  `device_id` int(10) unsigned NOT NULL auto_increment,
  `hostname` varchar(40) NOT NULL default '',
  `description` varchar(100) NOT NULL default '',
  `disabled` char(2) default '',
  `ignorePorts` varchar(35) default '',
  `ips_total` varchar(10) NOT NULL default '0',
  `vlans_total` varchar(10) NOT NULL default '0',
  `ports_total` varchar(10) NOT NULL default '0',
  `ports_active` varchar(10) NOT NULL default '0',
  `ports_trunk` varchar(10) NOT NULL default '0',
  `scan_type` tinyint(11) NOT NULL default '1',
  `snmp_readstring` varchar(20) NOT NULL default '',
  `snmp_readstrings` varchar(100) default NULL,
  `snmp_version` varchar(100) NOT NULL default '',
  `snmp_timeout` varchar(100) NOT NULL default '',
  `snmp_retries` varchar(100) NOT NULL default '',
  `snmp_sysObjectID` varchar(100) default NULL,
  `snmp_sysDescr` varchar(100) default NULL,
  `snmp_sysUptime` varchar(100) default NULL,
  `snmp_status` int(10) unsigned NOT NULL default '0',
  `last_runmessage` varchar(100) default '',
  `last_rundate` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_runduration` decimal(9,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`device_id`,`hostname`),
  KEY `site_id` (`site_id`)
) TYPE=MyISAM COMMENT='Devices to be scanned for MAC addresses';

--
-- Dumping data for table `mac_track_devices`
--


/*!40000 ALTER TABLE `mac_track_devices` DISABLE KEYS */;
LOCK TABLES `mac_track_devices` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mac_track_devices` ENABLE KEYS */;

--
-- Table structure for table `mac_track_ips`
--

DROP TABLE IF EXISTS `mac_track_ips`;
CREATE TABLE `mac_track_ips` (
  `site_id` int(10) unsigned NOT NULL default '0',
  `device_id` int(10) unsigned NOT NULL default '0',
  `hostname` varchar(40) NOT NULL default '',
  `description` varchar(100) NOT NULL default '',
  `port_number` varchar(10) NOT NULL default '',
  `mac_address` varchar(20) NOT NULL default '',
  `ip_address` varchar(20) NOT NULL default '',
  `scan_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`scan_date`,`ip_address`,`mac_address`,`site_id`),
  KEY `ip` (`ip_address`),
  KEY `port_number` (`port_number`),
  KEY `mac` (`mac_address`),
  KEY `device_id` (`device_id`),
  KEY `site_id` (`site_id`),
  KEY `hostname` (`hostname`),
  KEY `scan_date` (`scan_date`)
) TYPE=MyISAM;

--
-- Dumping data for table `mac_track_ips`
--


/*!40000 ALTER TABLE `mac_track_ips` DISABLE KEYS */;
LOCK TABLES `mac_track_ips` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mac_track_ips` ENABLE KEYS */;

--
-- Table structure for table `mac_track_ports`
--

DROP TABLE IF EXISTS `mac_track_ports`;
CREATE TABLE `mac_track_ports` (
  `site_id` int(10) unsigned NOT NULL default '0',
  `device_id` int(10) unsigned NOT NULL default '0',
  `hostname` varchar(40) NOT NULL default '',
  `description` varchar(100) NOT NULL default '',
  `vlan_id` varchar(5) NOT NULL default 'N/A',
  `vlan_name` varchar(50) NOT NULL default '',
  `mac_address` varchar(20) NOT NULL default '',
  `ip_address` varchar(20) NOT NULL default '',
  `port_number` varchar(10) NOT NULL default '',
  `port_name` varchar(50) NOT NULL default '',
  `scan_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`port_number`,`scan_date`,`mac_address`,`device_id`),
  KEY `site_id` (`site_id`),
  KEY `description` (`description`),
  KEY `mac` (`mac_address`),
  KEY `hostname` (`hostname`),
  KEY `vlan_name` (`vlan_name`),
  KEY `vlan_id` (`vlan_id`),
  KEY `device_id` (`device_id`),
  KEY `ip_address` (`ip_address`)
) TYPE=MyISAM COMMENT='Database for Tracking Device MAC''s';

--
-- Dumping data for table `mac_track_ports`
--


/*!40000 ALTER TABLE `mac_track_ports` DISABLE KEYS */;
LOCK TABLES `mac_track_ports` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mac_track_ports` ENABLE KEYS */;

--
-- Table structure for table `mac_track_processes`
--

DROP TABLE IF EXISTS `mac_track_processes`;
CREATE TABLE `mac_track_processes` (
  `process_id` int(11) NOT NULL default '0',
  `status` varchar(20) NOT NULL default 'Queued',
  `start_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`process_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `mac_track_processes`
--


/*!40000 ALTER TABLE `mac_track_processes` DISABLE KEYS */;
LOCK TABLES `mac_track_processes` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mac_track_processes` ENABLE KEYS */;

--
-- Table structure for table `mac_track_sites`
--

DROP TABLE IF EXISTS `mac_track_sites`;
CREATE TABLE `mac_track_sites` (
  `site_id` int(10) unsigned NOT NULL auto_increment,
  `site_name` varchar(100) NOT NULL default '',
  `total_devices` int(10) unsigned NOT NULL default '0',
  `total_device_errors` int(10) unsigned NOT NULL default '0',
  `total_macs` int(10) unsigned NOT NULL default '0',
  `total_ips` int(10) unsigned NOT NULL default '0',
  `total_user_ports` int(11) NOT NULL default '0',
  `total_trunk_ports` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`site_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `mac_track_sites`
--


/*!40000 ALTER TABLE `mac_track_sites` DISABLE KEYS */;
LOCK TABLES `mac_track_sites` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mac_track_sites` ENABLE KEYS */;

--
-- Table structure for table `mac_track_temp_ports`
--

DROP TABLE IF EXISTS `mac_track_temp_ports`;
CREATE TABLE `mac_track_temp_ports` (
  `site_id` int(10) unsigned NOT NULL default '0',
  `device_id` int(10) unsigned NOT NULL default '0',
  `hostname` varchar(40) NOT NULL default '',
  `description` varchar(100) NOT NULL default '',
  `vlan_id` varchar(5) NOT NULL default 'N/A',
  `vlan_name` varchar(50) NOT NULL default '',
  `mac_address` varchar(20) NOT NULL default '',
  `ip_address` varchar(20) NOT NULL default '',
  `port_number` varchar(10) NOT NULL default '',
  `port_name` varchar(50) NOT NULL default '',
  `scan_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`port_number`,`scan_date`,`mac_address`,`device_id`),
  KEY `site_id` (`site_id`),
  KEY `description` (`description`),
  KEY `ip_address` (`ip_address`),
  KEY `hostname` (`hostname`),
  KEY `vlan_name` (`vlan_name`),
  KEY `vlan_id` (`vlan_id`),
  KEY `device_id` (`device_id`),
  KEY `mac` (`mac_address`)
) TYPE=MyISAM COMMENT='Database for Storing Temporary Results for Tracking Device M';

--
-- Dumping data for table `mac_track_temp_ports`
--


/*!40000 ALTER TABLE `mac_track_temp_ports` DISABLE KEYS */;
LOCK TABLES `mac_track_temp_ports` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mac_track_temp_ports` ENABLE KEYS */;

