<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

chdir('../../');

include("./include/auth.php");
include_once("./lib/snmp.php");

define("MAX_DISPLAY_PAGES", 21);

$device_type_actions = array(
	1 => "Delete"
	);

/* set default action */
if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }

switch ($_REQUEST["action"]) {
	case 'save':
		form_save();

		break;
	case 'actions':
		form_actions();

		break;
	case 'edit':
		include_once("./include/top_header.php");

		mactrack_device_type_edit();

		include_once("./include/bottom_footer.php");
		break;
	default:
		include_once("./include/top_header.php");

		mactrack_device_type();

		include_once("./include/bottom_footer.php");
		break;
}

/* --------------------------
    The Save Function
   -------------------------- */

function form_save() {
	if ((isset($_POST["save_component_device_type"])) && (empty($_POST["add_dq_y"]))) {
		$device_type_id = api_mactrack_device_type_save($_POST["device_type_id"], $_POST["description"],
			$_POST["device_type"], $_POST["sysDescr_match"], $_POST["sysObjectID_match"],
			$_POST["scanning_function"], $_POST["lowPort"], $_POST["highPort"]);

		if ((is_error_message()) || ($_POST["device_type_id"] != $_POST["_device_type_id"])) {
			header("Location: mactrack_device_types.php?action=edit&device_type_id=" . (empty($device_type_id) ? $_POST["device_type_id"] : $device_type_id));
		}else{
			header("Location: mactrack_device_types.php");
		}
	}
}

function api_mactrack_device_type_remove($device_type_id){
	db_execute("DELETE FROM mac_track_device_types WHERE device_type_id=" . $device_type_id);
}

function api_mactrack_device_type_save($device_type_id, $description,
			$device_type, $sysDescr_match, $sysObjectID_match, $scanning_function,
			$lowPort, $highPort) {

	$save["device_type_id"] = $device_type_id;
	$save["description"] = form_input_validate($description, "description", "", false, 3);
	$save["device_type"] = $device_type;
	$save["sysDescr_match"] = form_input_validate($sysDescr_match, "sysDescr_match", "", true, 3);
	$save["sysObjectID_match"] = form_input_validate($sysObjectID_match, "sysObjectID_match", "", true, 3);
	$save["scanning_function"] = form_input_validate($scanning_function, "scanning_function", "", true, 3);
	$save["lowPort"] = form_input_validate($lowPort, "lowPort", "", true, 3);
	$save["highPort"] = form_input_validate($highPort, "highPort", "", true, 3);

	$device_type_id = 0;
	if (!is_error_message()) {
		$device_type_id = sql_save($save, "mac_track_device_types", "device_type_id");

		if ($device_type_id) {
			raise_message(1);
		}else{
			raise_message(2);
		}
	}

	return $device_type_id;
}

/* ------------------------
    The "actions" function
   ------------------------ */

function form_actions() {
	global $colors, $device_actions, $device_types_actions, $fields_mactrack_device_types_edit;

	/* if we are to save this form, instead of display it */
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));

		if ($_POST["drp_action"] == "1") { /* delete */
			for ($i=0; $i<count($selected_items); $i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				api_mactrack_device_type_remove($selected_items[$i]);
			}
		}

		header("Location: mactrack_device_types.php");
		exit;
	}

	/* setup some variables */
	$device_type_list = ""; $i = 0;

	/* loop through each of the host templates selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$device_types_info = db_fetch_row("SELECT description FROM mac_track_device_types WHERE device_type_id=" . $matches[1]);
			$device_types_list .= "<li>" . $device_types_info["description"] . "<br>";
			$device_types_array[$i] = $matches[1];
		}

		$i++;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $device_types_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='mactrack_device_types.php' method='post'>\n";

	if ($_POST["drp_action"] == "1") { /* delete */
		print "	<tr>
				<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>Are you sure you want to delete the following device types?</p>
					<p>$device_type_list</p>
				</td>
			</tr>\n
			";
	}

	if (!isset($device_types_array)) {
		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one device type.</span></td></tr>\n";
		$save_html = "";
	}else{
		$save_html = "<input type='image' src='images/button_yes.gif' alt='Save' align='absmiddle'>";
	}

	print "	<tr>
			<td colspan='2' align='right' bgcolor='#eaeaea'>
				<input type='hidden' name='action' value='actions'>
				<input type='hidden' name='selected_items' value='" . (isset($device_array) ? serialize($device_array) : '') . "'>
				<input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
				<a href='mactrack_device_types.php'><img src='images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
				$save_html
			</td>
		</tr>
		";

	html_end_box();

	include_once("./include/bottom_footer.php");
}

/* ---------------------
    Mactrack Device Type Functions
   --------------------- */

function mactrack_device_type_remove() {
	global $config;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("device_type_id"));
	/* ==================================================== */

	if ((read_config_option("remove_verification") == "on") && (!isset($_GET["confirm"]))) {
		include("./include/top_header.php");
		form_confirm("Are You Sure?", "Are you sure you want to delete the device type<strong>'" . db_fetch_cell("select description from host where id=" . $_GET["device_id"]) . "'</strong>?", "mactrack_device_types.php", "mactrack_device_types.php?action=remove&id=" . $_GET["device_type_id"]);
		include("./include/bottom_footer.php");
		exit;
	}

	if ((read_config_option("remove_verification") == "") || (isset($_GET["confirm"]))) {
		api_mactrack_device_type_remove($_GET["device_type_id"]);
	}
}

function mactrack_device_type_edit() {
	global $colors, $fields_mactrack_device_type_edit;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("device_type_id"));
	/* ==================================================== */

	display_output_messages();

	if (!empty($_GET["device_type_id"])) {
		$device_type = db_fetch_row("select * from mac_track_device_types where device_type_id=" . $_GET["device_type_id"]);
		$header_label = "[edit: " . $device_type["description"] . "]";
	}else{
		$header_label = "[new]";
	}

	html_start_box("<strong>Mac Track Device Types</strong> $header_label", "98%", $colors["header"], "3", "center", "");

	draw_edit_form(array(
		"config" => array("form_name" => "chk"),
		"fields" => inject_form_variables($fields_mactrack_device_type_edit, (isset($device_type) ? $device_type : array()))
		));

	html_end_box();

	form_save_button("mactrack_device_types.php", "", "device_type_id");
}

function mactrack_device_type() {
	global $colors, $device_type_actions, $mac_track_device_types, $config;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_request("page"));
//	input_validate_input_number(get_request_var_request("vendor"));
	input_validate_input_number(get_request_var_request("type_id"));
	/* ==================================================== */

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_mactrack_device_type_current_page", "1");
	load_current_session_value("vendor", "sess_mactrack_device_type_vendor", "All");
	load_current_session_value("type_id", "sess_mactrack_device_type_type_id", "-1");

	$sql_where = "";

	if ($_REQUEST["vendor"] == "All") {
		/* Show all items */
	}else{
		$sql_where = " WHERE (mac_track_device_types.vendor='" . $_REQUEST["vendor"] . "'";
	}

	if ($_REQUEST["type_id"] == "-1") {
		/* Show all items */
	}else{
		if (strlen($sql_where) > 0) {
			$sql_where .= " AND mac_track_device_types.device_type=" . $_REQUEST["type_id"] . ")";
		}else{
			$sql_where .= " WHERE (mac_track_device_types.device_type=" . $_REQUEST["type_id"] . ")";
		}
	}

	html_start_box("<strong>Mac Track Device Type Filters</strong>", "98%", $colors["header"], "3", "center", "mactrack_device_types.php?action=edit");

	include("plugins/mac_track/html/inc_mactrack_device_type_filter_table.php");

	html_end_box();

	html_start_box("", "98%", $colors["header"], "3", "center", "");

	$total_rows = db_fetch_cell("SELECT
		COUNT(mac_track_device_types.device_type_id)
		FROM mac_track_device_types" . $sql_where);

	$device_types = db_fetch_assoc("SELECT
		mac_track_device_types.device_type_id,
		mac_track_device_types.description,
		mac_track_device_types.vendor,
		mac_track_device_types.device_type,
		mac_track_device_types.sysDescr_match,
		mac_track_device_types.sysObjectID_match,
		mac_track_device_types.scanning_function,
		mac_track_device_types.lowPort,
		mac_track_device_types.highPort
		FROM mac_track_device_types
		$sql_where
		ORDER BY mac_track_device_types.vendor, mac_track_device_types.device_type, mac_track_device_types.description
		LIMIT " . (read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1)) . "," . read_config_option("num_rows_mactrack"));

	/* generate page list */
	$url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, read_config_option("num_rows_mactrack"), $total_rows, "mactrack_device_types.php?");

	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='7'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='mactrack_device_types.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . ((read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < read_config_option("num_rows_mactrack")) || ($total_rows < (read_config_option("num_rows_mactrack")*$_REQUEST["page"]))) ? $total_rows : (read_config_option("num_rows_mactrack")*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * read_config_option("num_rows_mactrack")) < $total_rows) { $nav .= "<a class='linkOverDark' href='mactrack_device_types.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * read_config_option("num_rows_mactrack")) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

	html_header_checkbox(array("Device Type<br>Description", "Device<br>Vendor", "Device<br>Type", "sysDescription<br>Match", "Vendor OID<br>Match"));

/*				<td><?php print ($device_type["device_type"] == "3" ? "Not Applicable" : $device_type["scanning_function"])?></td> */

	$i = 0;
	if (sizeof($device_types) > 0) {
		foreach ($device_types as $device_type) {
			form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
				?>
				<td width=170>
					<a class="linkEditMain" href="mactrack_device_types.php?action=edit&device_type_id=<?php print $device_type["device_type_id"];?>"><?php print $device_type["description"];?></a>
				</td>
				<td><?php print $device_type["vendor"];?></td>
				<td><?php print $mac_track_device_types[$device_type["device_type"]];?></td>
				<td><?php print $device_type["sysDescr_match"];?></td>
				<td><?php print $device_type["sysObjectID_match"];?></td>
				<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
					<input type='checkbox' style='margin: 0px;' name='chk_<?php print $device_type["device_id"];?>' title="<?php print $device_type["description"];?>">
				</td>
			</tr>
			<?php
		}

		/* put the nav bar on the bottom as well */
		print $nav;
	}else{
		print "<tr><td><em>No Mac Track Device Types</em></td></tr>";
	}
	html_end_box(false);

	/* draw the dropdown containing a list of available actions for this form */
	draw_actions_dropdown($device_type_actions);
}

?>