<?php



function plugin_init_mac_track() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['mac_track'] = 'mac_track_show_tab';
	$plugin_hooks['top_graph_header_tabs']['mac_track'] = 'mac_track_show_tab';
	$plugin_hooks['config_arrays']['mac_track'] = 'mac_track_config_arrays';
	$plugin_hooks['draw_navigation_text']['mac_track'] = 'mac_track_draw_navigation_text';
	$plugin_hooks['config_form']['mac_track'] = 'mac_track_config_form';
	$plugin_hooks['config_settings']['mac_track'] = 'mac_track_config_settings';
	$plugin_hooks['poller_bottom']['mac_track'] = 'mac_track_poller_bottom';
}

function mac_track_poller_bottom () {
	global $config;
	include_once($config["base_path"] . "/lib/poller.php");
	include_once($config["base_path"] . "/lib/data_query.php");
	include_once($config["base_path"] . "/lib/graph_export.php");
	include_once($config["base_path"] . "/lib/rrd.php");

	$command_string = read_config_option("path_php_binary");
	$extra_args = "-q " . $config["base_path"] . "/plugins/mac_track/poller_mactrack.php";
	exec_background($command_string, "$extra_args");
}

function mac_track_config_settings () {
	global $tabs, $settings, $mactrack_snmp_versions;

	$tabs["mactrack"] = "Device Tracking";

	$settings["mactrack"] = array(
		"mactrack_hdr_timing" => array(
			"friendly_name" => "Mac Track General Settings",
			"method" => "spacer",
			),
		"mt_processes" => array(
			"friendly_name" => "Number of Concurrent Processes",
			"description" => "Specify how many devices will be polled simultaneously until all devices have been polled.",
			"default" => "7",
			"method" => "textbox",
			"max_length" => "10"
			),
		"mt_collection_timing" => array(
			"friendly_name" => "Data Collection Timing",
			"description" => "Choose when collect MAC and IP Address information from your network devices.",
			"method" => "drop_array",
			"default" => "disabled",
			"array" => array(
				"disabled" => "Disabled",
				"60" => "Every 1 Hour",
				"120" => "Every 2 Hours",
				"240" => "Every 4 Hours",
				"480" => "Every 8 Hours",
				"720" => "Every 12 Hours",
				"1440" => "Every Day"
				),
			),
		"mt_script_runtime" => array(
			"friendly_name" => "Device Scanner Max Runtime",
			"description" => "Specify the number of minutes a device scanning function will allowed to run prior to the system assuming it has been completed.  This setting will correct for abended scanning jobs.",
			"default" => "20",
			"method" => "textbox",
			"max_length" => "10"
			),
		"mt_base_time" => array(
			"friendly_name" => "Start Time for Data Collection",
			"description" => "When would you like the first data collection to take place.  All future data collection times will be based upon this start time.  A good example would be 12:00AM.",
			"default" => "1:00am",
			"method" => "textbox",
			"max_length" => "10"
			),
		"mt_maint_time" => array(
			"friendly_name" => "Database Maintenance Time",
			"description" => "When should old database records be removed from the database.  Please note that no access will be permitted to the port database while this action is taking place.",
			"default" => "12:00am",
			"method" => "textbox",
			"max_length" => "10"
			),
		"mt_data_retention" => array(
			"friendly_name" => "Data Retention Duration",
			"description" => "How long should port MAC details be retained in the database.",
			"method" => "drop_array",
			"default" => "2weeks",
			"array" => array(
				"2days" => "2 Days",
				"5days" => "5 Days",
				"1week" => "1 Week",
				"2weeks" => "2 Weeks",
				"3weeks" => "3 Weeks",
				"1month" => "1 Month",
				"2months" => "2 Months"
				),
			),
		"mactrack_hdr_general" => array(
			"friendly_name" => "Mac Track SNMP Settings",
			"method" => "spacer",
			),
		"mt_snmp_ver" => array(
			"friendly_name" => "SNMP Version",
			"description" => "Default SNMP version for all new hosts.",
			"method" => "drop_array",
			"default" => "Version 1",
			"array" => $mactrack_snmp_versions,
			),
		"mt_snmp_community" => array(
			"friendly_name" => "SNMP Community",
			"description" => "Default SNMP read community for all new hosts.",
			"method" => "textbox",
			"default" => "public",
			"max_length" => "100"
			),
		"mt_snmp_communities" => array(
			"friendly_name" => "SNMP Communities",
			"description" => "Fill in the list of available SNMP read strings to test for this device. Each read string must be separated by a colon ':'.  These read strings will be tested sequentially if the primary read string is invalid.",
			"method" => "textbox",
			"default" => "public:private:secret",
			"max_length" => "100"
			),
		"mt_snmp_timeout" => array(
			"friendly_name" => "SNMP Timeout",
			"description" => "Default SNMP timeout in milli-seconds.",
			"method" => "textbox",
			"default" => "500",
			"max_length" => "100"
			),
		"mt_snmp_retries" => array(
			"friendly_name" => "SNMP Retries",
			"description" => "The number times the SNMP poller will attempt to reach the host before failing.",
			"method" => "textbox",
			"default" => "3",
			"max_length" => "100"
			)
		);
		
		$settings["visual"]["mactrack_header"] = array(
			"friendly_name" => "Device Tracking",
			"method" => "spacer",
			);
		$settings["visual"]["num_rows_mactrack"] = array(
			"friendly_name" => "Rows Per Page",
			"description" => "The number of rows to display on a single page for Device Tracking sites, devices and reports.",
			"method" => "textbox",
			"default" => "30",
			"max_length" => "10"
			);
		$ts = array();
		foreach ($settings['path'] as $t => $ta) {
			$ts[$t] = $ta;
			if ($t == 'path_snmpget') {
				$ts["path_snmpbulkwalk"] = array(
					"friendly_name" => "snmpbulkwalk Binary Path",
					"description" => "The path to your snmpbulkwalk binary.",
					"method" => "textbox",
					"max_length" => "255"
					);
			}
		}
		$settings['path']=$ts;
}

function mac_track_draw_navigation_text ($nav) {
	$nav["mactrack_devices.php:"] = array("title" => "Mac Track Devices", "mapping" => "index.php:", "url" => "mactrack_devices.php", "level" => "1");
	$nav["mactrack_devices.php:edit"] = array("title" => "(Edit)", "mapping" => "index.php:,mactrack_devices.php:", "url" => "", "level" => "2");
	$nav["mactrack_devices.php:actions"] = array("title" => "Actions", "mapping" => "index.php:,mactrack_devices.php:", "url" => "", "level" => "2");
	$nav["mactrack_device_types.php:"] = array("title" => "Mac Track Device Types", "mapping" => "index.php:", "url" => "mactrack_device_types.php", "level" => "1");
	$nav["mactrack_device_types.php:edit"] = array("title" => "(Edit)", "mapping" => "index.php:,mactrack_device_types.php:", "url" => "", "level" => "2");
	$nav["mactrack_device_types.php:actions"] = array("title" => "Actions", "mapping" => "index.php:,mactrack_device_types.php:", "url" => "", "level" => "2");
	$nav["mactrack_sites.php:"] = array("title" => "Mac Track Sites", "mapping" => "index.php:", "url" => "mactrack_sites.php", "level" => "1");
	$nav["mactrack_sites.php:edit"] = array("title" => "(Edit)", "mapping" => "index.php:,mactrack_sites.php:", "url" => "", "level" => "2");
	$nav["mactrack_sites.php:actions"] = array("title" => "Actions", "mapping" => "index.php:,mactrack_sites.php:", "url" => "", "level" => "2");
	$nav["mactrack_view.php:"] = array("title" => "Mac Track Viewer", "mapping" => "index.php:", "url" => "mactrack_view.php", "level" => "1");
	return $nav;
}

function mac_track_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id = 0;
	if (isset($user_auth_realm_filenames{basename('mactrack_view.php')})) {
		$realm_id = $user_auth_realm_filenames{basename('mactrack_view.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id'")) || (empty($realm_id))) {
		print '<a href="' . $config['url_path'] . 'plugins/mac_track/mactrack_view.php"><img src="' . $config['url_path'] . 'plugins/mac_track/images/tab_mactrack.gif" alt="mac_track" align="absmiddle" border="0"></a>';
	}
}

function mac_track_config_arrays () {
	global $mactrack_snmp_versions, $mac_track_device_types, $mac_track_search_types;
	global $user_auth_realms, $user_auth_realm_filenames, $menu, $config;

	$user_auth_realms[20]='View MacTrack Data';
	$user_auth_realm_filenames['mactrack_view.php'] = 20;
	$user_auth_realms[21]='Update MacTrack Sites/Devices/Types';
	$user_auth_realm_filenames['mactrack_devices.php'] = 21;
	$user_auth_realm_filenames['mactrack_sites.php'] = 21;
	$user_auth_realm_filenames['mactrack_device_types.php'] = 21;

	$mactrack_snmp_versions = array(1 =>
		"Version 1",
		"Version 2");

	$mac_track_device_types = array(
		1 => "Switch/Hub",
		2 => "Switch/Router",
		3 => "Router");

	$mac_track_search_types = array(
		1 => "Matches",
		2 => "Contains",
		3 => "Begins With",
		4 => "Does Not Contain",
		5 => "Does Not Begin With",
		6 => "Is Null",
		7 => "Is Not Null");

	$menu2 = array ();
	foreach ($menu as $temp => $temp2 ) {
		$menu2[$temp] = $temp2;
		if ($temp == 'Management') {
			$menu2["Device Tracking"]["plugins/mac_track/mactrack_sites.php"] = "Sites";
			$menu2["Device Tracking"]["plugins/mac_track/mactrack_devices.php"] = "Devices";
			$menu2["Device Tracking"]["plugins/mac_track/mactrack_device_types.php"] = "Device Types";
		}
	}
	$menu = $menu2;
}

function mac_track_config_form () {
	global $fields_mactrack_device_type_edit, $fields_mactrack_device_edit, $fields_mactrack_site_edit;
	global $mac_track_device_types, $mactrack_snmp_versions;

	$fields_mactrack_device_type_edit = array(
	"spacer0" => array(
		"method" => "spacer",
		"friendly_name" => "Device Scanning Function Options"
		),
	"description" => array(
		"method" => "textbox",
		"friendly_name" => "Description",
		"description" => "Give this device type a meaningful description.",
		"value" => "|arg1:description|",
		"max_length" => "250"
		),
	"vendor" => array(
		"method" => "textbox",
		"friendly_name" => "Vendor",
		"description" => "Fill in the name for the vendor of this device type.",
		"value" => "|arg1:vendor|",
		"max_length" => "250"
		),
	"device_type" => array(
		"method" => "drop_array",
		"friendly_name" => "Device Type",
		"description" => "Choose the type of device.",
		"value" => "|arg1:device_type|",
		"default" => 1,
		"array" => $mac_track_device_types
		),
	"sysDescr_match" => array(
		"method" => "textbox",
		"friendly_name" => "System Description Match",
		"description" => "Provide key information to help MacTrack detect the type of device.  The wildcard character is the '%' sign.",
		"value" => "|arg1:sysDescr_match|",
		"max_length" => "250"
		),
	"sysObjectID_match" => array(
		"method" => "textbox",
		"friendly_name" => "Vendor snmp Object ID Match",
		"description" => "Provide key information to help MacTrack detect the type of device.  The wildcard character is the '%' sign.",
		"value" => "|arg1:sysObjectID_match|",
		"max_length" => "250"
		),
	"scanning_function" => array(
		"method" => "textbox",
		"friendly_name" => "Scanning Function",
		"description" => "The MacTrack scanning function to call in order to obtain and store port details.  The function name is all that is required.  The following four parameters are assumed and will always be appended: 'my_function(\$site, &\$device, \$lowport, \$highport)'.  There is no function required for a pure router.",
		"value" => "|arg1:scanning_function|",
		"default" => "",
		"max_length" => "100"
		),
	"lowPort" => array(
		"method" => "textbox",
		"friendly_name" => "Low User Port Number",
		"description" => "Provide the low user port number on this switch.  Leave 0 to allow the system to calculate it.",
		"value" => "|arg1:lowPort|",
		"default" => read_config_option("mt_port_lowPort"),
		"max_length" => "100"
		),
	"highPort" => array(
		"method" => "textbox",
		"friendly_name" => "High User Port Number",
		"description" => "Provide the low user port number on this switch.  Leave 0 to allow the system to calculate it.",
		"value" => "|arg1:highPort|",
		"default" => read_config_option("mt_port_highPort"),
		"max_length" => "100"
		),
	"device_type_id" => array(
		"method" => "hidden_zero",
		"value" => "|arg1:device_type_id|"
		),
	"_device_type_id" => array(
		"method" => "hidden_zero",
		"value" => "|arg1:device_type_id|"
		),
	"save_component_device_type" => array(
		"method" => "hidden",
		"value" => "1"
		)
	);

	/* file: mactrack_devices.php, action: edit */
	$fields_mactrack_device_edit = array(
	"spacer0" => array(
		"method" => "spacer",
		"friendly_name" => "General Device Settings"
		),
	"description" => array(
		"method" => "textbox",
		"friendly_name" => "Description",
		"description" => "Give this device a meaningful description.",
		"value" => "|arg1:description|",
		"max_length" => "250"
		),
	"hostname" => array(
		"method" => "textbox",
		"friendly_name" => "Hostname",
		"description" => "Fill in the fully qualified hostname for this device.",
		"value" => "|arg1:hostname|",
		"max_length" => "250"
		),
	"scan_type" => array(
		"method" => "drop_array",
		"friendly_name" => "Scan Type",
		"description" => "Choose the scan type you wish to perform on this device.",
		"value" => "|arg1:scan_type|",
		"default" => 1,
		"array" => $mac_track_device_types
		),
	"site_id" => array(
		"method" => "drop_sql",
		"friendly_name" => "Site Name",
		"description" => "Choose the site to associate with this device.",
		"value" => "|arg1:site_id|",
		"none_value" => "None",
		"sql" => "select site_id as id,site_name as name from mac_track_sites order by name"
		),
	"disabled" => array(
		"method" => "checkbox",
		"friendly_name" => "Disable Device",
		"description" => "Check this box to disable all checks for this host.",
		"value" => "|arg1:disabled|",
		"default" => "",
		"form_id" => false
		),
	"spacer1" => array(
		"method" => "spacer",
		"friendly_name" => "Hub/Switch, Switch/Router Settings"
		),
	"port_ignorePorts" => array(
		"method" => "textbox",
		"friendly_name" => "Ports to Ignore",
		"description" => "Provide a list of ports on a specific switch/hub whose MAC results should be ignored.  Ports such as link/trunk ports that can not be distinguished from other user ports are examples.  Each port number must be separated by a comma.  For example, 'Fa0/1, Fa1/23' would be acceptable for some manufacturers switch types.",
		"value" => "|arg1:ignorePorts|",
		"default" => read_config_option("mt_port_ignorePorts"),
		"max_length" => "100"
		),
	"spacer2" => array(
		"method" => "spacer",
		"friendly_name" => "SNMP Settings"
		),
	"snmp_readstring" => array(
		"method" => "textbox",
		"friendly_name" => "SNMP Readstring",
		"description" => "Fill in the SNMP read community for this device.",
		"value" => "|arg1:snmp_readstring|",
		"default" => read_config_option("mt_snmp_community"),
		"max_length" => "100"
		),
	"snmp_readstrings" => array(
		"method" => "textbox",
		"friendly_name" => "SNMP Rotation Readstrings",
		"description" => "Fill in the list of available SNMP read strings to test for this device. Each read string must be separated by a colon ':'.  These read strings will be tested sequentially if the primary read string is invalid.",
		"value" => "|arg1:snmp_readstrings|",
		"default" => read_config_option("mt_snmp_communities"),
		"max_length" => "100"
		),
	"snmp_version" => array(
		"method" => "drop_array",
		"friendly_name" => "SNMP Version",
		"description" => "Choose the SNMP version for this host.",
		"value" => "|arg1:snmp_version|",
		"default" => read_config_option("mt_snmp_ver"),
		"array" => $mactrack_snmp_versions
		),
	"snmp_timeout" => array(
		"method" => "textbox",
		"friendly_name" => "SNMP Timeout",
		"description" => "The maximum number of milliseconds Cacti will wait for an SNMP response (does not work with php-snmp support).",
		"value" => "|arg1:snmp_timeout|",
		"max_length" => "8",
		"default" => read_config_option("mt_snmp_timeout"),
		"size" => "15"
		),
	"snmp_retries" => array(
		"method" => "textbox",
		"friendly_name" => "SNMP Retries",
		"description" => "The maximum number of attempts to reach a device via an SNMP readstring prior to giving up.",
		"value" => "|arg1:snmp_retries|",
		"max_length" => "8",
		"default" => read_config_option("mt_snmp_retries"),
		"size" => "15"
		),
	"device_id" => array(
		"method" => "hidden_zero",
		"value" => "|arg1:device_id|"
		),
	"_device_id" => array(
		"method" => "hidden_zero",
		"value" => "|arg1:device_id|"
		),
	"save_component_device" => array(
		"method" => "hidden",
		"value" => "1"
		)
	);

	/* file: mactrack_sites.php, action: edit */
	$fields_mactrack_site_edit = array(
	"spacer0" => array(
		"method" => "spacer",
		"friendly_name" => "General Site Settings"
		),
	"site_name" => array(
		"method" => "textbox",
		"friendly_name" => "Site Name",
		"description" => "Please enter a reasonable name for this site.",
		"value" => "|arg1:site_name|",
		"max_length" => "250"
		),
	"site_id" => array(
		"method" => "hidden_zero",
		"value" => "|arg1:site_id|"
		),
	"_site_id" => array(
		"method" => "hidden_zero",
		"value" => "|arg1:site_id|"
		),
	"save_component_site" => array(
		"method" => "hidden",
		"value" => "1"
		)
	);

}

?>